if(!window.visionaustralia){
     window.visionaustralia = {};
}

//MATCH FUNCTION START-----------------------------------------------------------------------------------------------------------
function myMatch(inputText){
//Example match function
//the input to the function is the text in the input field, the output is array of strings. the strings can contain basic formatting
//markup e.g. "Ab<span style="text-decoration:underline;">er</span>feldy Township"
//You can include nested arrays of strings in the output. This will be displayed as nested lists in the drop down
//e.g output could be ["A",["Ale","Arm","Ask"],"C",["Calm","Clam","Cramp"]];

     var matches = [];

     if(inputText =="") return matches;

     //sample total list of options
     var allOptions = ["Aberfeldy Township","Altona","Arthurs Creek","Arthurs Seat","Ashwood","Bacchus Marsh Werribee River","Ballan","Beaconsfield Upper","Beenak","Berwick","Blackburn","Blackburn North","Blue Mountain","Box Hill","Braeside","Braeside Park","Broadmeadows","Brooklyn","Bulla","Bulla North","Bulleen","Bundoora","Burnley","Burwood East","Cambarville","Cardinia","Caulfield","Caulfield North","Cement Creek","Christmas Hills","Clarkefield","Clarkefield","Clayton","Clearwater Aqueduct","Coburg","Coldstream","Collingwood","Craigieburn","Craigieburn East","Cranbourne","Dandenong","Dandenong South","Dandenong West","Darraweit","Deer Park","Devilbend Reservoir","Diggers Rest","Dixons Creek","Doncaster","Doncaster East","Drouin West","Durdidwarrah","Eastern G.C. Doncaster","Elsternwick","Eltham","Emerald","Epping","Essendon","Fairfield","Fawkner","Fiskville","Flemington","Footscray","Frankston North","Frankston Pier","Gardiner","Glen Forbes South","Glen Waverley","Graceburn","Graceburn Creek Aqueduct","Greensborough","Greenvale Reservoir","Groom's Hill","Hampton","Hampton Park","Hawthorn","Headworks","Healesville","Heathmont","Heidelberg","Hurstbridge","Iona","Ivanhoe","Kangaroo Ground","Keilor","Keilor North","Kew","Keysborough","Kinglake","Knox","Konagaderra","Kooweerup","Lake Borrie","Lancefield","Lancefield North","Launching Place","Lilydale Lake","Little River","Loch","Longwarry North","Lower Plenty","Lyndhurst","Lysterfield","Maribyrnong","Maroondah Reservoir","Melton Reservoir","Melton Sth Toolern Creek","Mentone","Mernda","Millgrove","Mitcham","Montrose","Mooroolbark","Mornington","Mount Dandenong","Mount Evelyn","Mount View","Mt Blackwood","Mt Bullengarook","Mt Donna Buang","Mt Evelyn Stringybark Creek","Mt Gregory","Mt Hope","Mt Horsfall","Mt Juliet","Mt Macedon","Mt St Gwinear","Mt St Leonard","Mt Waverley","Myrrhee","Narre Warren North","Nayook","Neerim South","Neerim-Elton Rd","Neerim-Neerim Creek","Neerim-Tarago East Branch","Neerim-Tarago West Branch","North Wharf","Northcote","Notting Hill","Nutfield","O'Shannassy Reservoir","Oakleigh South","Officer","Officer South","Olinda","Pakenham","Pakenham East","Pakenham West","Parwon Parwan Creek","Poley Tower","Preston","Reservoir","Ringwood","Rockbank","Romsey","Rosslynne Reservoir","Rowville","Sandringham","Scoresby","Seaford","Seaford North","Seville East","Silvan","Smiths Gully","Somerton","Southbank","Spotswood","Springvale","St Albans","St Kilda Marina","Sunbury","Sunshine","Surrey Hills","Tarago Reservoir","Tarrawarra","Templestowe","The Basin","Thomson Dam","Tonimbuk","Toolern Vale","Torourrong Reservoir","U/S Goodman Creek Lerderderg River","Upper Lang Lang","Upper Pakenham","Upper Yarra Dam","Wallaby Creek","Wallan","Wantirna South","Warrandyte","Williamstown","Woori Yallock","Woori Yallock Creek","Wyndham Vale","Yallock outflow Cora Lyn","Yannathan","Yarra Glen","Yarra Glen Steels Creek","Yarra Junction","Yarra River downstream Doctors Creek","Yellingbo","Yering"];

     for(var i=0,len=allOptions.length;i<len;i++){

         var txt = allOptions[i].trim();
         var LCtxt = txt.toLowerCase();

         var n=LCtxt.indexOf(inputText.toLowerCase());
         if(n>-1){
             var ll = inputText.length;
             var newTxt = txt.slice(0,n) + "<span style='text-decoration:underline;'>" + txt.slice(n,n+ll) + "</span>" + txt.slice(n+ll);
             matches.push(newTxt);
         }
     }
     return matches;
}
//MATCH FUNCTION END--------------------------------------------------------------------------------------------------------------



//top level closure
(function(){

     //define styles
     var cssOffleft ={
         position:"absolute",
         left:"-999px"
     };

     var cssDropdown ={
         listStyleType:"none",
         position: "absolute",
         backgroundColor: "white",
         margin:"1px",
         padding:"1px",
         border:"1px solid lightgrey",
         maxHeight:"200px",
         minWidth:"100px",
         overflow: "auto",
         paddingLeft:"2px",
		 right:"auto"
     };

     var cssLi={
         margin:"0px",
         padding:"0px"
     };

     var cssButton ={
         backgroundColor:"white",
         border:"none",
         outline:"none",
         textAlign:"left",
         margin:"0px",
         padding:"0px",
		 width:"100%",
		 cursor:"pointer"
     }

     var cssButtonFocus ={
         outline:"none",
         backgroundColor:"blue",
         color:"white"
     };

     var cssButtonUnFocus ={
         outline:"none",
         backgroundColor:"white",
         color:"black"
     };


     function ltrim(s) {
         return s.replace(/^\s+/,"");
     }

     //ensure public function is called after page load
     function makeAutocomplete (inputId,selectId){ $(function(){makeAutocompleteAfterPageLoad(inputId,selectId);});
     }

     function makeAutocompleteAfterPageLoad(inputId,matchFunction){
	 
	    //if($("#vaautocompletestyle").length < 1){
			//$('head').append('<style id="vaautocompletestyle" type="text/css">.vaautocomplete, .vaautocomplete * {all:initial;box-sizing:border-box;}</style>');
		//}

         //distance between input element element and visible options
         var topOffset = 5;
         var leftOffset = -1;

         var body = $("body");

         var input = $("#" + inputId);
         var inputLabel = $("label[for=" + inputId + "]");

         var inputText = $('<span> - type to filter then select from list below</span>');
         inputText.css(cssOffleft);

         inputLabel.append(inputText);

         input.attr("autocomplete","off");

         var noMatches = "No matches";

         var prevText = "";
         var ul;
         var prevIndex = -1;
         var matches = [];

         var span;

         function removeUl(){
             if(ul){
                 ul.remove();
                 ul=null;
                 //remove eventlistener from body
                 body.off("click",removeUl);
             }
         }

         //use keyup because only then is the actual character in the input field
         input.keyup(function(ev){

              //if Tab key - ignore
             if(ev.which == 9){
                 return;
             }

             //remove spaces at start
             var text = ltrim(input.val());
             //if no change in text, do nothing
             if(text == prevText){return;}

            
			setTimeout(doRest,0);

			function doRest(){

				//keep this value for next time keydown event handler is called
				 prevText = text;

				 //if no matches: insert text "No matches" in ul
				 //if some matches: insert the matches in ul
				 //ul is only removed if you select an option OR click outside the input field


				 //remove visible options
				 removeUlContent();


				 //could place "Loading" in drop-down


				 if(!ul){
					 ul = $('<div role="list" class="vaautocomplete"></div>');
					 ul.css(cssDropdown);
					 input.after(ul);
					 //add event handler to body
					 body.on("click",removeUl);
				 }

				 //store buttons to add event handlers afterwards
				 var buttons = [];

				 //fill matches array with matching items
				 matches = matchFunction(text);

				 //if no matches
				 if(matches.length==0){
					 if(input.val() != ""){

						 //lazy - use fake button so CSS is the same
						 var VOItem = $('<button role="presentation">No matches</button>');
						 VOItem.css(cssButton);

						 VOItem.click(function(){
							 removeUlContent();
							 removeUl();
							 input.focus();
							 prevText = input.val();
						 });

						 VOItem.focus(function(){
							 $(this).css(cssButtonFocus);
						 });

						 VOItem.blur(function(){
							 $(this).css(cssButtonUnFocus);
						 });

						 //ADD DOWN ARROW event handler
						 VOItem.keydown(function(ev){
							 //escape
							 if(ev.which == 27){
								 removeUlContent();
								 input.focus();
							 }
						 });

						 VOItem.keydown(function(ev){
							 //uparrow
							 if(ev.which == 38){
								 input.focus();
								 //removeUlContent();
							 }
						 });

						 var li = $('<div role="listitem"></li>');
						 li.css(cssLi);
						 li.append(VOItem);
						 ul.append(li);

						 buttons.push(VOItem);

					 }else{
						 removeUlContent();
						 removeUl();
					 }
				 }



				 addMatches(matches,ul);

				 //recursive function
				 function addMatches(matches, container){
					 //adds <li> elements to <ul> element (container)

					 if(matches.length==0) return;

					 var lastListItem = null;

					 //add matches to list
					 for(var i=0,len=matches.length;i<len;i++){

						 if(matches[i] instanceof Array){
							 var listEl = $('<div role="list"></div>');
							 if(!lastListItem){
								 var listIt = $('<div role="listitem"></div>');
								 listIt.css(cssLi);
								 addMatches(matches[i],listEl);
								 listIt.append(listEl);
								 container.append(listIt);
							 }else{
								 addMatches(matches[i],listEl);
								 lastListItem.append(listEl);
							 }
							 continue;
						 }

						 var textVal = matches[i];

						 var VOItem = $('<button>' + textVal + '</button>');
						 VOItem.attr("aria-label",VOItem.text());
						 VOItem.css(cssButton);

						 //this closes the visible options and finalses selection
						 VOItem.click(function(){

							 var t = matches[i];

							 //place text of selected item in input field
							 input.val($(this).text());

							 //remove visible drop-down
							 removeUlContent();
							 removeUl();

							 //place focus on input element
							 input.focus();
							 //ensure that options do not show next time input field gets a keypress
							 prevText = input.val();
						 });

						 VOItem.focus(function(){
							 $(this).css(cssButtonFocus);
						 });

						 VOItem.blur(function(){
							 $(this).css(cssButtonUnFocus);
						 });

						 buttons.push(VOItem);

						 lastListItem = $('<div role="listitem"></li>');
						 lastListItem.css(cssLi);
						 lastListItem.append(VOItem);
						 container.append(lastListItem);
					 }
				 }

				 var pos=input.offset();
				 position(input,ul);



				 //add event handlers to buttons, bar first and last
				 for(var k=1,klen=buttons.length-1;k<klen;k++){
					 (function(k){
						 var VOItem = buttons[k];

						 //ADD DOWN ARROW event handler
						 VOItem.keydown(function(ev){
							 //escape
							 if(ev.which == 27){
								 removeUlContent();
								 removeUl();
								 input.focus();
							 //if downarrow - move keyboard focus to the select element
							 }else if(ev.which == 40){

								 buttons[k+1].focus();
								 //alert(k+1);
								 ev.preventDefault();
								 //ev.stopPropagation();
							 //uparrow
							 }else if(ev.which == 38){

								 buttons[k-1].focus();

								 //aler(prevButton.nodeName);
								 ev.preventDefault();
							 }
						 });

					 })(k);
				 }

				 if(buttons.length >1){
					 //add event handlers to first button
					 var VOItem = buttons[0];
					 VOItem.keydown(function(ev){
						 //escape
						 if(ev.which == 27){
							 removeUlContent();
							 removeUl();
							 input.focus();
						 //if downarrow
						 }else if(ev.which == 40){

							 buttons[1].focus();

							 ev.preventDefault();
							 //ev.stopPropagation(); xxxx
						 //uparrow
						 }else if(ev.which == 38){

							 input.focus();
							 ev.preventDefault();
						 }
					 });

					 //add event handlers to last button
					 var VOItem = buttons[klen];
					 VOItem.keydown(function(ev){
						 //escape
						 if(ev.which == 27){
							 removeUlContent();
							 removeUl();
							 input.focus();
						 //if downarrow
						 }else if(ev.which == 40){

							 ev.preventDefault();
						 //uparrow
						 }else if(ev.which == 38){

							 buttons[klen-1].focus();
							 ev.preventDefault();
						 }
					 });

				 }else if(buttons.length==1){
					 var VOItem = buttons[0];
					 VOItem.keydown(function(ev){
						 //escape
						 if(ev.which == 27){
							 removeUlContent();
							 removeUl();
							 input.focus();
						 //if downarrow
						 }else if(ev.which == 40){
							 ev.preventDefault();
						 //uparrow
						 }else if(ev.which == 38){
							 input.focus();
							 ev.preventDefault();
						 }
					 });
				 }


				 /*
				 if (span) {
					 span.text(buttons.length + " matches");
					 input.after(span);
					 span.after(ul);
				 }
				 */

				input.after(ul);
			}

         //end keyup keyup keyup keyup keyup keyup keyup keyup keyup keyup keyup keyup keyup keyup keyup
         });


         input.keydown(function(ev){
             //down arrow, move to suggestions
             if(ev.which == 40){
                 if(ul){
                     //span.focus();
					setTimeout(function(){ul.children(":first-child").children().focus();},100);
                 }
                 ev.preventDefault();
                 return;
             }
         });


         function removeUlContent(){
             if(ul)ul.empty();
             if(span)span.remove();
             //span = null;
             //reset array of visible options
             VOArray = [];
             //reset index of current selection
             prevIndex = -1;
         }

         $(window).resize(function(){position(input,ul);});

         function position(original,newcomer){
             if(!newcomer)return;
             var o = original.position();
             var h = original.height();
             var w = original.innerWidth();//width plus padding
             w = w - parseInt(newcomer.css("padding-left")) - parseInt(newcomer.css("padding-right"));
             newcomer.css({ 'top': o.top + h + topOffset + 'px', 'left': o.left + leftOffset + 'px','min-width': w + 'px'}).show();
         }

     }//end makeAutoComplete

     //add public function
     window.visionaustralia.makeAutocomplete = makeAutocomplete;

//end top level closure
})();
